import sys
from threading import Thread
import socket

import pyosd

class Lirc(Thread):
    def __init__(self, modes, config, mode = "films"):
        Thread.__init__(self)
        
        self._config = config
        self._socket = socket.socket(socket.AF_UNIX)
        
        try:
            self._socket.connect("/dev/lircd")
        except socket.error:
            sys.stderr.write("lirc: unable to open socket\n")
            self._socket = None
        
        self._mode = mode
        self._modes = modes
        
        self._osd = pyosd.osd()
        self._osd.set_align(pyosd.ALIGN_RIGHT)
    
    def run(self):
        driver = self._modes[self._mode]
        
        while self._socket:
            msg = self._socket.recv(1024)
            lines = msg.splitlines()
            for l in lines:
                (_, count, key, cmd) = l.split(" ")
                count = int(count, 16)
                
                if count == 0:
                    actions = None
                    
                    if self._mode in self._config and key in self._config[self._mode]:
                        actions = self._config[self._mode][key]
                    elif '_' in self._config and key in self._config['_']:
                        actions = self._config['_'][key]
                    
                    if actions is not None:
                        if type(actions) == dict:
                            for (k, v) in actions.iteritems():
                                if k == "continue":
                                    k = "continue_last"
                                if k == "mode":
                                    self._mode = v
                                    driver = self._modes[self._mode]
                                    self._osd.display(self._mode)
                                else:
                                    if v is None:
                                        eval("driver.%s()" % k)
                                    else:
                                        eval("driver.%s(\"%s\")" % (k, v))
                        
                        elif type(actions) == list:
                            for a in actions:
                                if a == "continue":
                                    a = "continue_last"
                                eval("driver.%s()" % a)
                        
                        else:
                            if actions == "continue":
                                actions = "continue_last"
                            eval("driver.%s()" % actions)
                    
                    else:
                        print "lirc: key %s is unknown" % key
    
